var fdSlicer=require("../"),fs=require("fs"),crypto=require("crypto"),path=require("path"),streamEqual=require("stream-equal"),assert=require("assert"),Pend=require("pend"),StreamSink=require("streamsink"),describe=global.describe,it=global.it,before=global.before,beforeEach=global.beforeEach,after=global.after,testBlobFile=path.join(__dirname,"test-blob.bin"),testBlobFileSize=20971520,testOutBlobFile=path.join(__dirname,"test-blob-out.bin");describe("FdSlicer",function(){before(function(e){for(var t=fs.createWriteStream(testBlobFile),r=0;r<testBlobFileSize/1024;r+=1)t.write(crypto.pseudoRandomBytes(1024));t.end(),t.on("close",e)}),beforeEach(function(){try{fs.unlinkSync(testOutBlobFile)}catch(e){}}),after(function(){try{fs.unlinkSync(testBlobFile),fs.unlinkSync(testOutBlobFile)}catch(e){}}),it("reads a 20MB file (autoClose on)",function(e){fs.open(testBlobFile,"r",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createReadStream(),o=fs.createReadStream(testBlobFile),a=new Pend;a.go(function(e){i.on("close",e)}),a.go(function(t){streamEqual(o,n,function(r,i){if(r)return e(r);assert.ok(i),t()})}),a.wait(e)})}),it("reads 4 chunks simultaneously",function(e){fs.open(testBlobFile,"r",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r),n=i.createReadStream({start:0*testBlobFileSize/4,end:1*testBlobFileSize/4}),o=i.createReadStream({start:1*testBlobFileSize/4,end:2*testBlobFileSize/4}),a=i.createReadStream({start:2*testBlobFileSize/4,end:3*testBlobFileSize/4}),s=i.createReadStream({start:3*testBlobFileSize/4,end:4*testBlobFileSize/4}),f=i.createReadStream({start:0*testBlobFileSize/4,end:1*testBlobFileSize/4}),l=i.createReadStream({start:1*testBlobFileSize/4,end:2*testBlobFileSize/4}),c=i.createReadStream({start:2*testBlobFileSize/4,end:3*testBlobFileSize/4}),u=i.createReadStream({start:3*testBlobFileSize/4,end:4*testBlobFileSize/4}),d=new Pend;d.go(function(e){streamEqual(f,n,function(t,r){assert.ok(r),e(t)})}),d.go(function(e){streamEqual(l,o,function(t,r){assert.ok(r),e(t)})}),d.go(function(e){streamEqual(c,a,function(t,r){assert.ok(r),e(t)})}),d.go(function(e){streamEqual(u,s,function(t,r){assert.ok(r),e(t)})}),d.wait(function(t){if(t)return e(t);fs.close(r,e)})})}),it("writes a 20MB file (autoClose on)",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream(),o=fs.createReadStream(testBlobFile);i.on("close",function(){var t=fs.createReadStream(testBlobFile),r=fs.createReadStream(testOutBlobFile);streamEqual(t,r,function(t,r){if(t)return e(t);assert.ok(r),e()})}),o.pipe(n)})}),it("writes 4 chunks simultaneously",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r),n=i.createWriteStream({start:0*testBlobFileSize/4}),o=i.createWriteStream({start:1*testBlobFileSize/4}),a=i.createWriteStream({start:2*testBlobFileSize/4}),s=i.createWriteStream({start:3*testBlobFileSize/4}),f=fs.createReadStream(testBlobFile,{start:0*testBlobFileSize/4,end:1*testBlobFileSize/4}),l=fs.createReadStream(testBlobFile,{start:1*testBlobFileSize/4,end:2*testBlobFileSize/4}),c=fs.createReadStream(testBlobFile,{start:2*testBlobFileSize/4,end:3*testBlobFileSize/4}),u=fs.createReadStream(testBlobFile,{start:3*testBlobFileSize/4,end:4*testBlobFileSize/4}),d=new Pend;d.go(function(e){n.on("finish",e)}),d.go(function(e){o.on("finish",e)}),d.go(function(e){a.on("finish",e)}),d.go(function(e){s.on("finish",e)}),f.pipe(n),l.pipe(o),c.pipe(a),u.pipe(s),d.wait(function(){fs.close(r,function(t){if(t)return e(t);var r=fs.createReadStream(testBlobFile),i=fs.createReadStream(testOutBlobFile);streamEqual(r,i,function(t,r){if(t)return e(t);assert.ok(r),e()})})})})}),it("throws on invalid ref",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0});assert.throws(function(){i.unref()},/invalid unref/),fs.close(r,e)})}),it("write stream emits error when max size exceeded",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream({start:0,end:1e3});n.on("error",function(t){assert.strictEqual(t.code,"ETOOBIG"),i.on("close",e)}),n.end(new Buffer(1001))})}),it("write stream does not emit error when max size not exceeded",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream({end:1e3});i.on("close",e),n.end(new Buffer(1e3))})}),it("write stream start and end work together",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream({start:1,end:1e3});n.on("error",function(t){assert.strictEqual(t.code,"ETOOBIG"),i.on("close",e)}),n.end(new Buffer(1e3))})}),it("write stream emits progress events",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream(),o=0,a=0;n.on("progress",function(){o+=1,assert.ok(n.bytesWritten>a),a=n.bytesWritten}),i.on("close",function(){assert.ok(o>5),e()});for(var s=0;s<10;s+=1)n.write(new Buffer(32768));n.end()})}),it("write stream unrefs when destroyed",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createWriteStream();i.on("close",e),n.write(new Buffer(1e3)),n.destroy()})}),it("read stream unrefs when destroyed",function(e){fs.open(testBlobFile,"r",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r,{autoClose:!0}),n=i.createReadStream();n.on("error",function(t){assert.strictEqual(t.message,"stream destroyed"),i.on("close",e)}),n.destroy()})}),it("fdSlicer.read",function(e){fs.open(testBlobFile,"r",function(t,r){if(t)return e(t);var i=fdSlicer.createFromFd(r),n=new Buffer(1024);i.read(n,0,10,0,function(t,i,n){assert.strictEqual(i,10),fs.close(r,e)})})}),it("fdSlicer.write",function(e){fs.open(testOutBlobFile,"w",function(t,r){if(t)return e(t);fdSlicer.createFromFd(r).write(new Buffer("blah\n"),0,5,0,function(){if(t)return e(t);fs.close(r,e)})})})}),describe("BufferSlicer",function(){it("invalid ref",function(){var e=fdSlicer.createFromBuffer(new Buffer(16));e.ref(),e.unref(),assert.throws(function(){e.unref()},/invalid unref/)}),it("read and write",function(e){var t=new Buffer("through the tangled thread the needle finds its way"),r=fdSlicer.createFromBuffer(t),i=new Buffer(1024);r.read(i,10,11,8,function(n){if(n)return e(n);assert.strictEqual(i.toString("utf8",10,21),"the tangled"),r.write(new Buffer("derp"),0,4,7,function(r){if(r)return e(r);assert.strictEqual(t.toString("utf8",7,19),"derp tangled"),e()})})}),it("createReadStream",function(e){var t="I never conquered rarely came, 16 just held such better days",r=new Buffer(t),i=fdSlicer.createFromBuffer(r).createReadStream(),n=new StreamSink;i.pipe(n),n.on("finish",function(){assert.strictEqual(n.toString(),t),i.destroy(),e()})}),it("createWriteStream exceed buffer size",function(e){var t=fdSlicer.createFromBuffer(new Buffer(4)).createWriteStream();t.on("error",function(t){assert.strictEqual(t.code,"ETOOBIG"),e()}),t.write("hi!\n"),t.write("it warked\n"),t.end()}),it("createWriteStream ok",function(e){var t=new Buffer(1024),r=fdSlicer.createFromBuffer(t).createWriteStream();r.on("finish",function(){assert.strictEqual(t.toString("utf8",0,"hi!\nit warked\n".length),"hi!\nit warked\n"),r.destroy(),e()}),r.write("hi!\n"),r.write("it warked\n"),r.end()})});