"use strict";var crypto=require("crypto"),util=require("util"),Extensions=require("websocket-extensions"),Base=require("./base"),Frame=require("./hybi/frame"),Message=require("./hybi/message"),Hybi=function(e,t,s){if(Base.apply(this,arguments),this._extensions=new Extensions,this._stage=0,this._masking=this._options.masking,this._protocols=this._options.protocols||[],this._requireMasking=this._options.requireMasking,this._pingCallbacks={},"string"==typeof this._protocols&&(this._protocols=this._protocols.split(/ *, */)),this._request){var i=this._request.headers["sec-websocket-key"],r=this._request.headers["sec-websocket-protocol"],n=this._request.headers["sec-websocket-version"],a=this._protocols;this._headers.set("Upgrade","websocket"),this._headers.set("Connection","Upgrade"),this._headers.set("Sec-WebSocket-Accept",Hybi.generateAccept(i)),void 0!==r&&("string"==typeof r&&(r=r.split(/ *, */)),this.protocol=r.filter(function(e){return a.indexOf(e)>=0})[0],this.protocol&&this._headers.set("Sec-WebSocket-Protocol",this.protocol)),this.version="hybi-"+n}};util.inherits(Hybi,Base),Hybi.mask=function(e,t,s){if(!t||0===t.length)return e;s=s||0;for(var i=0,r=e.length-s;i<r;i++)e[s+i]=e[s+i]^t[i%4];return e},Hybi.generateAccept=function(e){var t=crypto.createHash("sha1");return t.update(e+Hybi.GUID),t.digest("base64")},Hybi.GUID="258EAFA5-E914-47DA-95CA-C5AB0DC85B11";var instance={FIN:128,MASK:128,RSV1:64,RSV2:32,RSV3:16,OPCODE:15,LENGTH:127,OPCODES:{continuation:0,text:1,binary:2,close:8,ping:9,pong:10},OPCODE_CODES:[0,1,2,8,9,10],MESSAGE_OPCODES:[0,1,2],OPENING_OPCODES:[1,2],ERRORS:{normal_closure:1e3,going_away:1001,protocol_error:1002,unacceptable:1003,encoding_error:1007,policy_violation:1008,too_large:1009,extension_error:1010,unexpected_condition:1011},ERROR_CODES:[1e3,1001,1002,1003,1007,1008,1009,1010,1011],DEFAULT_ERROR_CODE:1e3,MIN_RESERVED_ERROR:3e3,MAX_RESERVED_ERROR:4999,UTF8_MATCH:/^([\x00-\x7F]|[\xC2-\xDF][\x80-\xBF]|\xE0[\xA0-\xBF][\x80-\xBF]|[\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}|\xED[\x80-\x9F][\x80-\xBF]|\xF0[\x90-\xBF][\x80-\xBF]{2}|[\xF1-\xF3][\x80-\xBF]{3}|\xF4[\x80-\x8F][\x80-\xBF]{2})*$/,addExtension:function(e){return this._extensions.add(e),!0},parse:function(e){this._reader.put(e);for(var t=!0;t;)switch(this._stage){case 0:(t=this._reader.read(1))&&this._parseOpcode(t[0]);break;case 1:(t=this._reader.read(1))&&this._parseLength(t[0]);break;case 2:(t=this._reader.read(this._frame.lengthBytes))&&this._parseExtendedLength(t);break;case 3:(t=this._reader.read(4))&&(this._stage=4,this._frame.maskingKey=t);break;case 4:(t=this._reader.read(this._frame.length))&&(this._stage=0,this._emitFrame(t));break;default:t=null}},text:function(e){return!(this.readyState>1)&&this.frame(e,"text")},binary:function(e){return!(this.readyState>1)&&this.frame(e,"binary")},ping:function(e,t){return!(this.readyState>1)&&(e=e||"",t&&(this._pingCallbacks[e]=t),this.frame(e,"ping"))},pong:function(e){return!(this.readyState>1)&&(e=e||"",this.frame(e,"pong"))},close:function(e,t){return e=e||"",t=t||this.ERRORS.normal_closure,this.readyState<=0?(this.readyState=3,this.emit("close",new Base.CloseEvent(t,e)),!0):1===this.readyState&&(this.readyState=2,this._extensions.close(function(){this.frame(e,"close",t)},this),!0)},frame:function(e,t,s){if(this.readyState<=0)return this._queue([e,t,s]);if(this.readyState>2)return!1;e instanceof Array&&(e=new Buffer(e)),"number"==typeof e&&(e=e.toString());var i,r,n=new Message,a="string"==typeof e;n.rsv1=n.rsv2=n.rsv3=!1,n.opcode=this.OPCODES[t||(a?"text":"binary")],i=a?new Buffer(e,"utf8"):e,s&&(r=i,(i=new Buffer(2+r.length)).writeUInt16BE(s,0),r.copy(i,2)),n.data=i;var o=function(e){var t=new Frame;t.final=!0,t.rsv1=e.rsv1,t.rsv2=e.rsv2,t.rsv3=e.rsv3,t.opcode=e.opcode,t.masked=!!this._masking,t.length=e.data.length,t.payload=e.data,t.masked&&(t.maskingKey=crypto.randomBytes(4)),this._sendFrame(t)};return this.MESSAGE_OPCODES.indexOf(n.opcode)>=0?this._extensions.processOutgoingMessage(n,function(e,t){if(e)return this._fail("extension_error",e.message);o.call(this,t)},this):o.call(this,n),!0},_sendFrame:function(e){var t=e.length,s=t<=125?2:t<=65535?4:10,i=s+(e.masked?4:0),r=new Buffer(i+t),n=e.masked?this.MASK:0;r[0]=(e.final?this.FIN:0)|(e.rsv1?this.RSV1:0)|(e.rsv2?this.RSV2:0)|(e.rsv3?this.RSV3:0)|e.opcode,t<=125?r[1]=n|t:t<=65535?(r[1]=126|n,r.writeUInt16BE(t,2)):(r[1]=127|n,r.writeUInt32BE(Math.floor(t/4294967296),2),r.writeUInt32BE(t%4294967296,6)),e.payload.copy(r,i),e.masked&&(e.maskingKey.copy(r,s),Hybi.mask(r,e.maskingKey,i)),this._write(r)},_handshakeResponse:function(){try{var e=this._extensions.generateResponse(this._request.headers["sec-websocket-extensions"])}catch(e){return this._fail("protocol_error",e.message)}e&&this._headers.set("Sec-WebSocket-Extensions",e);var t=["HTTP/1.1 101 Switching Protocols",this._headers.toString(),""];return new Buffer(t.join("\r\n"),"utf8")},_shutdown:function(e,t,s){delete this._frame,delete this._message,this._stage=5;var i=1===this.readyState;this.readyState=2,this._extensions.close(function(){i&&this.frame(t,"close",e),this.readyState=3,s&&this.emit("error",new Error(t)),this.emit("close",new Base.CloseEvent(e,t))},this)},_fail:function(e,t){this.readyState>1||this._shutdown(this.ERRORS[e],t,!0)},_parseOpcode:function(e){var t=[this.RSV1,this.RSV2,this.RSV3].map(function(t){return(e&t)===t}),s=this._frame=new Frame;return s.final=(e&this.FIN)===this.FIN,s.rsv1=t[0],s.rsv2=t[1],s.rsv3=t[2],s.opcode=e&this.OPCODE,this._stage=1,this._extensions.validFrameRsv(s)?this.OPCODE_CODES.indexOf(s.opcode)<0?this._fail("protocol_error","Unrecognized frame opcode: "+s.opcode):this.MESSAGE_OPCODES.indexOf(s.opcode)<0&&!s.final?this._fail("protocol_error","Received fragmented control frame: opcode = "+s.opcode):this._message&&this.OPENING_OPCODES.indexOf(s.opcode)>=0?this._fail("protocol_error","Received new data frame but previous continuous frame is unfinished"):void 0:this._fail("protocol_error","One or more reserved bits are on: reserved1 = "+(s.rsv1?1:0)+", reserved2 = "+(s.rsv2?1:0)+", reserved3 = "+(s.rsv3?1:0))},_parseLength:function(e){var t=this._frame;if(t.masked=(e&this.MASK)===this.MASK,t.length=e&this.LENGTH,t.length>=0&&t.length<=125){if(this._stage=t.masked?3:4,!this._checkFrameLength())return}else this._stage=2,t.lengthBytes=126===t.length?2:8;if(this._requireMasking&&!t.masked)return this._fail("unacceptable","Received unmasked frame but masking is required")},_parseExtendedLength:function(e){var t=this._frame;if(t.length=this._readUInt(e),this._stage=t.masked?3:4,this.MESSAGE_OPCODES.indexOf(t.opcode)<0&&t.length>125)return this._fail("protocol_error","Received control frame having too long payload: "+t.length);this._checkFrameLength()},_checkFrameLength:function(){return!((this._message?this._message.length:0)+this._frame.length>this._maxLength)||(this._fail("too_large","WebSocket frame length too large"),!1)},_emitFrame:function(e){var t,s,i,r,n,a=this._frame,o=a.payload=Hybi.mask(e,a.maskingKey),h=a.opcode;if(delete this._frame,h===this.OPCODES.continuation){if(!this._message)return this._fail("protocol_error","Received unexpected continuation frame");this._message.pushFrame(a)}if(h!==this.OPCODES.text&&h!==this.OPCODES.binary||(this._message=new Message,this._message.pushFrame(a)),a.final&&this.MESSAGE_OPCODES.indexOf(h)>=0)return this._emitMessage(this._message);h===this.OPCODES.close&&(s=o.length>=2?o.readUInt16BE(0):null,i=o.length>2?this._encode(o.slice(2)):null,0!==o.length&&!(null!==s&&s>=this.MIN_RESERVED_ERROR&&s<=this.MAX_RESERVED_ERROR)&&this.ERROR_CODES.indexOf(s)<0&&(s=this.ERRORS.protocol_error),(o.length>125||o.length>2&&!i)&&(s=this.ERRORS.protocol_error),this._shutdown(s||this.DEFAULT_ERROR_CODE,i||"")),h===this.OPCODES.ping&&(this.frame(o,"pong"),this.emit("ping",new Base.PingEvent(o.toString()))),h===this.OPCODES.pong&&(n=(r=this._pingCallbacks)[t=this._encode(o)],delete r[t],n&&n(),this.emit("pong",new Base.PongEvent(o.toString())))},_emitMessage:function(e){(e=this._message).read(),delete this._message,this._extensions.processIncomingMessage(e,function(e,t){if(e)return this._fail("extension_error",e.message);var s=t.data;if(t.opcode===this.OPCODES.text&&(s=this._encode(s)),null===s)return this._fail("encoding_error","Could not decode a text frame as UTF-8");this.emit("message",new Base.MessageEvent(s))},this)},_encode:function(e){try{var t=e.toString("binary",0,e.length);if(!this.UTF8_MATCH.test(t))return null}catch(e){}return e.toString("utf8",0,e.length)},_readUInt:function(e){return 2===e.length?e.readUInt16BE(0):4294967296*e.readUInt32BE(0)+e.readUInt32BE(4)}};for(var key in instance)Hybi.prototype[key]=instance[key];module.exports=Hybi;